import numpy as np

import pickle, sys, os
from pycbc.types import FrequencySeries
from scipy.signal import tukey
from scipy.interpolate import interp1d

from ..utils.compute_utils import Ydirect, rolling
from ..utils import logger

try:
    import EOBRun_module
except ImportError:
    logger.warning("Unable to import EOBRun_module, TEOBResumS will not function properly.")
    pass


## SEOBNRE_S
if not sys.version_info > (3, 8):
    # Apparently, the pickle is broken for > python 3.7
    # ecc_indir = '/home/juan.calderonbustillo/example/'
    ecc_path = lambda x: os.path.join(os.path.dirname(__file__), "data/SEOBNRE_S", x)
    with open(ecc_path('fits_amp.pkl'), 'rb') as f:
        fits_a = pickle.load(f)
    with open(ecc_path('fits_phi.pkl'), 'rb') as f:
        fits_p = pickle.load(f)

    eim_a_B = np.loadtxt(ecc_path('eim_amp_B.txt'))
    eim_p_B = np.loadtxt(ecc_path('eim_phi_B.txt'))


## Two Surrogate functions:
 # Evaluate the fits at requested parameter
 # Evaluate the empirical interpolant using the fit evaluations to
 # estimate the BesselJ function at the requested nu parameter

def evalSurrogate_a(param):
    fit_evals = np.array([f(param) for f in fits_a])
    return np.dot(fit_evals, eim_a_B)


def evalSurrogate_p(param):
    fit_evals = np.array([f(param) for f in fits_p])
    return np.dot(fit_evals, eim_p_B)

def strain_hphc_from_ml_eccentric_model(time_array, total_mass, mass_ratio, spin1z, spin2z, eccentricity,
                                        luminosity_distance, theta_jn, phase, geocent_time, **waveform_arguments):

    delta_t = time_array[1] - time_array[0]

    ##### Since we know the surrogate does work for 65Msun, let's generate waveforms for this mass and then re-scale
    Mtot_nodim = total_mass / 65
    dL_nodim = luminosity_distance / 100

    mass_1 = 65 * mass_ratio / (1+mass_ratio)
    mass_2 = 65 - mass_1

    scale = Mtot_nodim / dL_nodim
    amp = evalSurrogate_a([mass_1, mass_2, spin1z, spin2z, eccentricity])
    phi = evalSurrogate_p([mass_1, mass_2, spin1z, spin2z, eccentricity])
    h22 = scale * amp * np.exp(1j*phi)

    # The waveform is generated by default at 4096Hz, which may be way higher than what we want. Therefore we resample.
    geometric_time_axis = np.arange(0, 1, 1/4096) * Mtot_nodim
    hinterp = interp1d(geometric_time_axis, h22)
    # The resampled_time_axis starts with 0, ends with Mtot_nodim * (1 - 1/4096)
    resampled_time_axis = np.arange(0, Mtot_nodim * 4095/4096, delta_t)
    h22s = hinterp(resampled_time_axis)
    h2m2s = np.conjugate(h22s)

    H = Ydirect(theta_jn, phase, 2,  2)*h22s +\
        Ydirect(theta_jn, phase, 2, -2)*h2m2s

    # Determine length of waveform segment to retain
    template_max_index = np.argmax(np.abs(h22s))
    template_max_time = resampled_wfm_time[template_max_index]
    gps_index = np.argmin(np.abs(time_array - geocent_time))

    t_start = waveform_arguments.get('t_start', None)
    template_start_idx = max(template_max_index - gps_index, 0) \
                         if t_start is not None else \
                         np.argmin(np.abs(resampled_wfm_time - (template_max_time + t_start)))

    max_post_merger = waveform_arguments.get('max_post_merger', None)
    if max_post_merger is not None:
        tmp_end_idx = np.argmin(np.abs(resampled_wfm_time - (template_max_time + max_post_merger)))
        # plus 1 index to match when max_post_merger is longer than the waveform tail
        template_end_idx = min(tmp_end_idx + 1, len(hp))
    else:
        # Take the shorter of the two:
        # Time_array tail length: len(time_array) - gps_index
        # Waveform tail length:   len(hp) - template_max_index
        template_end_idx = min(len(time_array) - gps_index + template_max_index, len(H))
    template_length = template_end_idx - template_start_idx
    # peak_to_start_len = template_max_index - template_start_idx

    # Initialise the final output waveform
    ta_len = len(time_array)
    H_output = np.zeros(ta_len, dtype=complex)
    # Place the waveform segment at the beginning of the output array
    H_output[:template_length] = H[template_start_idx : template_end_idx]
    # Apply tukey window to 1/3 of pre merger
    duration = time_array[-1] - time_array[0]
    alpha = (template_max_index - template_start_idx) * delta_t / duration * (2/3)
    # (max - start) * delta_t / 2 / (time_array[-1] / 2)
    window = tukey(ta_len, alpha=alpha)
    H_output = H_output * window

    # (temp_max_index - temp_start_idx) is the new peak idx after trimming the starting segment
    gt0 = waveform_arguments.get('gt0', True)
    gps_idx = 0 if gt0 else gps_index
    shift =  gps_idx - (template_max_index - template_start_idx)
    # Shift the waveform to the appropriate position
    if shift != 0:
        H_output = rolling(H_output, shift)

    return {'plus': H_output.real, 'cross': H_output.imag}


"""
## TEOBResumS
This section is entirely copied, and modified from:
    https://bitbucket.org/eob_ihes/teobresums/src/master/PyCBC/teobresums.py
    git hash: 15a7191139ff14fcb450cae573a6e03b3d669b0f
which was intended to adapt the TEOBResumS waveform in PyCBC.
Here, it is modified to work with Bilby, and with these choices:
    1. Remove support for tidal deformation lambda 1,2
    2. Remove support for spin x,y
    3. Added input for ecc_freq
These adjustments were made to fit to our eccentric case, and it
should be relative easy to undo them by following the original script.
Also, some constant dictionaries were replaced with their actual
values directly in places that they are used.

The TEOBResum eccentric model is based on this paper:
    https://journals.aps.org/prd/pdf/10.1103/PhysRevD.103.104021
"""

def modes_to_k(modes):
    """ Map (l, m) to linear index """
    return sorted([int(x[0]*(x[0]-1)/2 + x[1]-2) for x in modes])


def teobresums_td(
    time_array, total_mass, mass_ratio, spin_1z, spin_2z, luminosity_distance,
    iota, phase, eccentricity, geocent_time, **waveform_arguments
):
    """ Time-domain TEOBResumS """

# Mass ratio < 1
    mass_1 = total_mass / ( 1 + mass_ratio )
    mass_2 = total_mass - mass_1

    param = {
        'mass_1': mass_1,
        'mass_2': mass_2,
        'spin_1z': spin_1z,
        'spin_2z': spin_2z,
        'luminosity_distance': luminosity_distance,
        'iota': iota,
        'phase': phase,
        'eccentricity': eccentricity,
    }

    # These are the only 'meaningful' modes mentioned in the paper
    # (4,2) is too noisy to be reliable
    # (l,0) modes have poor analytical representations
    higher_mode_arr = [
        (2,2), (2,1), (3,2), (3,3), (4,3), (4,4), (5,5)]

    dt = waveform_arguments.get('delta_t', time_array[1] - time_array[0])
    param['delta_t']    = dt
    param['f_lower']    = waveform_arguments.get('f_low', 10)
    # The way ecc_freq is defined
    param['ecc_freq']   = waveform_arguments.get('ecc_freq', 1)
    # Take all ell < 4 modes if not specified
    param['mode_array'] = waveform_arguments.get('mode_array', higher_mode_arr)
    max_post_merger = waveform_arguments.get('max_post_merger', None)

    # TEOBResumS parameters
    param = teobresums_pars_update(param, 0)

    # Run the WF generator
    wfm_time, hp, hc  = EOBRun_module.EOBRunPy(param)
    H = hp - 1j* hc

    # Determine length of waveform segment to retain
    template_max_index = np.argmax(np.abs(H))
    template_max_time = wfm_time[template_max_index]
    gps_index = np.argmin(np.abs(time_array - geocent_time))
    template_start_idx = max(template_max_index - gps_index, 0)
    if max_post_merger is not None:
        tmp_end_idx = np.argmin(np.abs(wfm_time - (template_max_time + max_post_merger)))
        # plus 1 index to match when max_post_merger is longer than the waveform tail
        template_end_idx = min(tmp_end_idx + 1, len(hp))
    else:
        # Take the shorter of the two:
        # Time_array tail length: len(time_array) - gps_index
        # Waveform tail length:   len(hp) - template_max_index
        template_end_idx = min(len(time_array) - gps_index + template_max_index, len(hp))
    template_length = template_end_idx - template_start_idx
    # peak_to_start_len = template_max_index - template_start_idx
    H_trimmed = H[template_start_idx : template_end_idx]

    # Initialise the final output waveform
    ta_len = len(time_array)
    H_output = np.zeros(ta_len, dtype=complex)
    # Place the waveform segment at the beginning of the output array
    H_output[:template_length] = H_trimmed
    # Apply tukey window to 1/3 of pre merger
    duration = time_array[-1] - time_array[0]
    alpha = (template_max_index - template_start_idx) * dt / duration * (2/3)
    # (max - start) * dt / 3 / (time_array[-1] / 2)
    window = tukey(ta_len, alpha=alpha)
    H_output = H_output * window

    # (temp_max_index - temp_start_idx) is the new peak idx after trimming the starting segment
    gt0 = waveform_arguments.get('gt0', True)
    gps_idx = 0 if gt0 else gps_index
    shift =  gps_idx - (template_max_index - template_start_idx)
    # print(f"template_start_idx: {template_start_idx}, template_end_idx: {template_end_idx}")
    # print(f"shift: {shift}, len(hp): {len(hp)}")
    # print(f"len(hp): {len(hp)}, template_length: {template_length}")
    # print(f"template_max_index: {template_max_index}, gps_index: {gps_index}")

    # Shift the waveform to the appropriate position
    if shift != 0:
        H_output = rolling(H_output, shift)

    return {'plus': H_output.real, 'cross': H_output.imag}


def teobresums_fd(
    frequency_array, mass_1, mass_2, spin_1z, spin_2z, luminosity_distance,
    iota, phase, eccentricity, **waveform_arguments
):
    """ Frequency-domain TEOBResumS
    !!! This FD model has not yet tested !!!
    !!  It is not guaranteed that it would even work  !!
    !   Please use at your own risk   !
    """

    param = {
    'mass_1': mass_1,
    'mass_2': mass_2,
    'spin_1z': spin_1z,
    'spin_2z': spin_2z,
    'luminosity_distance': luminosity_distance,
    'iota': iota,
    'phase': phase,
    'eccentricity': eccentricity,
    }

    df       = waveform_arguments.get('delta_f', frequency_array[1] - frequency_array[0])
    flow     = waveform_arguments.get('f_low', frequency_array[0])
    param['delta_f'] = df
    param['f_lower'] = flow
    param['ecc_freq']   = waveform_arguments.get('ecc_freq', 10)
    param['mode_array'] = waveform_arguments.get('mode_array', [(2,2)])

    # TEOBResumS parameters
    param = teobresums_pars_update(param, 1)

    # Run the WF generator
    f, rhp, ihp, rhc, ihc  = EOBRun_module.EOBRunPy(param)
    hp = rhp -1j*ihp
    hc = rhc -1j*ihc

    offset = 0 # GPS time, fixed at 0

    # we need to extend the TEOBResumS output, which automatically
    # starts at f_low instead of 0
    N = int(flow/df)
    hp = np.pad(hp, (N,0),  mode='constant')
    hc = np.pad(hc, (N,0),  mode='constant')

    hpf = FrequencySeries(hp, delta_f=df, epoch=offset)
    hcf = FrequencySeries(hc, delta_f=df, epoch=offset)
    return hpf, hcf

def teobresums_pars_update(par, domain):
    """ Update TEOBResumS default parameters with pars """

    ## domain: 0 -> time; 1 -> freq
    ## Interpolation (interp_uniform_grid):
    #   0 -> No interpolation
    #   1 -> Yes, only h+,hx on a grid of given dt_interp (or srate_interp)
    #   2 -> Yes,  all modes on a grid of given dt_interp (or srate_interp)
    if domain == 0:
        par['interp_uniform_grid'] = 1
        srate     = 1./par['delta_t']
    elif domain == 1:
        par['interp_uniform_grid'] = 0
        df        = par['delta_f']
        par['df'] = df
        srate     = 4096. # default
        if par['delta_t'] is not None:
            srate = 1./par['delta_t']
    else:
        raise ValueError("Choose TD or FD waveform.")

    # TEOBResumS requires some parameters
    m1          = par['mass_1']
    m2          = par['mass_2']
    spin1z      = par['spin_1z']
    spin2z      = par['spin_2z']
    distance    = par['luminosity_distance']
    inclination = par['iota']
    coa_phase   = par['phase']
    ecc         = par['eccentricity']
    # ecc_freq    = par['ecc_freq']


    if par['mode_array'] is None:
        k = modes_to_k([(2,2)])
    else:
        k = modes_to_k(par['mode_array'])
        if k[0] < 0 or k[-1] > 34:
            raise ValueError("Invalid mode list.")

    # Check masses convention
    q = m1/m2
    if q < 1.0 :
        m1,m2 = m2,m1
        spin1z, spin2z = spin2z, spin1z
        q = 1./q

    # Set TEOBResumS parameters
    # Below we list all possible parameters as a reference for an
    # advanced used, though they are set to None and removed before
    # updating the dictionary with the use input 'pars'.
    # If those values are not set by user, then internal default are
    # used.
    # See `C/par/default.par` or wiki for more details.
    default = {
        # Intrinsic parameters
        'M' : m1+m2,
        'q' : q,
        'LambdaAl2' : 0,
        'LambdaBl2' : 0,
        'chi1' : spin1z,
        'chi2' : spin2z,
        'chi1x': 0,
        'chi1y': 0,
        'chi1z': spin1z,
        'chi1x': 0,
        'chi1y': 0,
        'chi1z': spin2z,
        # Extrinsic parameters
        'distance' : distance,
        'inclination' : inclination,
        'coalescence_angle': coa_phase,     # reference angle/phase at coalescence
        # Waveform settings
        'domain' : domain,                  # 0 = TD, 1 = FD
        'r0' : None,                        # Initial radius (Compute from initial GW freq.)
        'initial_frequency': par['f_lower'],# in Hz if use_geometric_units = 0, else in geometric units
        'use_mode_lm' : k,                  # List of waveform modes to use
        'use_geometric_units': 0,           # I/O units output: 1 = geometric, 0 = physical
        ## Interpolate the dynamics and waveform
        # 1. if TD, and interp_uniform_grid:
        #   i. NOT use_geometric_units -> 1/dt = srate_interp
        #   ii. use_geometric_units    ->  dt  = dt_interp
        # 2. if FD, dt_interp is ignored & f_max = srate_interp / 2
        'srate_interp': srate,              # In Hz.
        'dt_interp': None,                  # In geometric unit. Default: 0.5
        ## Interpolation of the merger dynamics, after the peak of Omega.
        #    - dt = dt_merger_interp
        'dt_merger_interp': None,           # In geometric unit. Default: 0.5
        ## Dynamics and waveform computed from ODE
        # If `ode_timestep=="Uniform"`:
        #   i. NOT use_geometric_units -> 1/dt = srate_interp
        #   ii. use_geometric_units    ->  dt  = dt_interp
        'srate': 2048,                      # In Hz.
        'dt': None,                         # In geometric unit. Default: 0.5
        # ODE
        'ode_timestep' : None,              # ODE timestep model. Options: ['adaptive', 'uniform', 'adaptive+uniform_after_LSO']
        'ode_abstol' : None,                # Absolute numerical tolerance.       Default: 1e-13
        'ode_reltol' : None,                # Relative numerical tolerance.       Default: 1e-11
        'ode_tmax' : None,                  # Maximum integration time.           Default: 1e9
        'ode_stop_radius' : None,           # Stop ODE evoluation at this r.      Default: 1.0
        'ode_stop_afterNdt' : None,         # Stop ODE evoluation N iterations
                                            # after the peak of orbital freq.     Default: 4
        # NQC stuff
        'nqc' : None,                       # How to set NQCs. Options: ['manual', 'auto', 'no']
        'nqc_coefs_flx' : None,             # NQC model used in the flux.       Defaults: {BBH/BHNS: nrfit_spin202002, BNS: None}
        'nqc_coefs_hlm' : None,             # NQC model used in the waveform.   Defaults: {BBH/BHNS: compute, BNS: None}
        # Tidal stuff
        "tides": 0,
        "tides_gravitomagnetic": 0,
        'use_tidal' : 0,                    # Tidal model.                 Defaults: {BBH: TIDES_OFF, BHNS: TEOBRESUM, BNS: TIDES_TEOBRESUM3} (see USETIDAL)
        'use_tidal_gravitomagnetic' : 0,    # Gravitomagnetic tides model. Defaults: {BBH/BHNS: TIDES_GM_OFF, BNS: TIDES_GM_PN}
        'pGSF_tidal' : None,                # GSF p-exponent.              Default = 4.0
        # Light ring and Last stable orbit
        'compute_LR' : 0,                   # Compute the light ring (LR)?
        'compute_LR_guess' : None,          # Initial guess of the LR
        'compute_LSO' : 0,                  # Compute the last stable orbit (LSO)?
        'compute_LSO_guess' : None,         # Iniital guess of the LSO
        # Post Adiabatic
        'postadiabatic_dynamics' : 0,         # Postadiabatic approxiamation (PA)?
        'postadiabatic_dynamics_N' : None,    # N-th order PA.                              Default: 8
        'postadiabatic_dynamics_size' : None, # Guess for the size of the PA dynamics.      Default: 800
        'postadiabatic_dynamics_stop' : None, # Stop after PA dynamics?                     Default: no
        'postadiabatic_dynamics_rmin' : None, # Stop PA dynamics at this separation value.  Default: 14.0
        # Additional options
        'use_speedytail' : None,            # Speed up the computation of the tail factor in h_lm and F_lm? Default: No
        'centrifugal_radius' : None,        # Model for the centrifugal radius.                             Default: {BBH/BHNS: NLO, BNS: NNLO}
        'use_flm' : None,                   # Model for radiation reactoin.                                 Default: {BBH/BHNS: HM, BNS: SSNLO}
        'size' : None,                      # Initial guess of the size of the waveform.                    Default: 500
        'ringdown_extend_array' : None,     # Extend the ringdown array                                     Default: 500
        # Output Control
        'output_hpc' : 0,                   # Output plus and cross polarisations
        'output_multipoles' : 0,            # Output the waveform multipoles h_lm
        'output_lm' : k,                    # List of modes to output (if `output_multipoles`==True)
        'output_dynamics' : 0,              # Output the EOB dynamics
        'output_ringdown': 0,               # Output the ringdown
        'output_dir': "./data/",            # The output directory if any of the above is "yes", but it does not seem to be working
        'arg_out': 0,                       # Function output, return modes hlm/hflm. Default = 0 (no)

        # Evolution

        # The following affect the evolution **only** if on teobresums-eccentric branch
        'ecc': ecc,                         # Eccentricity at the initial frequency.
        'ecc_freq': 1,               # 0,1,2: "PERIASTRON", "AVERAGE", "APASTRON", None -> AVERAGE
        # Hyperbolic settings
        'r_hyp': 0.,                        # Initial radius for hyperbolic orbits (0. -> r0 compute from fmin and ecc.)
        'H_hyp': None,                      # Initial energy for hyperbolic orbits
        'j_hyp': None,                      # Initial angular momentum for hyperbolic orbits

        }

    # Remove unset parameters (use internal defaults)
    # and return updated parameter list
    rm_none = {k: v for k, v in default.items() if v is not None}
    default.clear()
    default.update(rm_none)
    default.update(par)
    return default
